diff --git a/liboctave/operators/mx-inlines.cc b/liboctave/operators/mx-inlines.cc
--- a/liboctave/operators/mx-inlines.cc
+++ b/liboctave/operators/mx-inlines.cc
@@ -1349,7 +1669,7 @@ OP_CUMMINMAX_FCN2 (mx_inline_cummax, >)
       {                                                         \
         for (octave_idx_type i = 0; i < u; i++)                 \
           {                                                     \
-            F (v, r, n);                                        \
+            F (v, r, n, includenan);                            \
             v += n;                                             \
             r += n;                                             \
           }                                                     \
@@ -1358,7 +1678,7 @@ OP_CUMMINMAX_FCN2 (mx_inline_cummax, >)
       {                                                         \
         for (octave_idx_type i = 0; i < u; i++)                 \
           {                                                     \
-            F (v, r, l, n);                                     \
+            F (v, r, l, n, includenan);                         \
             v += l*n;                                           \
             r += l*n;                                           \
           }                                                     \
@@ -1367,7 +1687,8 @@ OP_CUMMINMAX_FCN2 (mx_inline_cummax, >)
   template <typename T>                                         \
   inline void                                                   \
   F (const T *v, T *r, octave_idx_type *ri,                     \
-     octave_idx_type l, octave_idx_type n, octave_idx_type u)   \
+     octave_idx_type l, octave_idx_type n, octave_idx_type u,   \
+     bool includenan)                                           \
   {                                                             \
     if (! n)                                                    \
       return;                                                   \
@@ -1375,7 +1696,7 @@ OP_CUMMINMAX_FCN2 (mx_inline_cummax, >)
       {                                                         \
         for (octave_idx_type i = 0; i < u; i++)                 \
           {                                                     \
-            F (v, r, ri, n);                                    \
+            F (v, r, ri, n, includenan);                        \
             v += n;                                             \
             r += n;                                             \
             ri += n;                                            \
@@ -1385,7 +1706,7 @@ OP_CUMMINMAX_FCN2 (mx_inline_cummax, >)
       {                                                         \
         for (octave_idx_type i = 0; i < u; i++)                 \
           {                                                     \
-            F (v, r, ri, l, n);                                 \
+            F (v, r, ri, l, n, includenan);                     \
             v += l*n;                                           \
             r += l*n;                                           \
             ri += l*n;                                          \
@@ -1580,7 +1901,8 @@ template <typename R>
 inline Array<R>
 do_mx_minmax_op (const Array<R>& src, int dim,
                  void (*mx_minmax_op) (const R *, R *, octave_idx_type,
-                                       octave_idx_type, octave_idx_type))
+                                       octave_idx_type, octave_idx_type, bool),
+                 bool includenan = false)
 {
   octave_idx_type l, n, u;
   dim_vector dims = src.dims ();
@@ -1591,7 +1913,7 @@ do_mx_minmax_op (const Array<R>& src, in
   dims.chop_trailing_singletons ();
 
   Array<R> ret (dims);
-  mx_minmax_op (src.data (), ret.fortran_vec (), l, n, u);
+  mx_minmax_op (src.data (), ret.fortran_vec (), l, n, u, includenan);
 
   return ret;
 }
@@ -1600,7 +1922,9 @@ template <typename R>
 inline Array<R>
 do_mx_minmax_op (const Array<R>& src, Array<octave_idx_type>& idx, int dim,
                  void (*mx_minmax_op) (const R *, R *, octave_idx_type *,
-                                       octave_idx_type, octave_idx_type, octave_idx_type))
+                                       octave_idx_type, octave_idx_type,
+                                       octave_idx_type, bool),
+                 bool includenan = false)
 {
   octave_idx_type l, n, u;
   dim_vector dims = src.dims ();
@@ -1614,7 +1938,7 @@ do_mx_minmax_op (const Array<R>& src, Ar
   if (idx.dims () != dims) idx = Array<octave_idx_type> (dims);
 
   mx_minmax_op (src.data (), ret.fortran_vec (), idx.fortran_vec (),
-                l, n, u);
+                l, n, u, includenan);
 
   return ret;
 }
@@ -1623,14 +1947,16 @@ template <typename R>
 inline Array<R>
 do_mx_cumminmax_op (const Array<R>& src, int dim,
                     void (*mx_cumminmax_op) (const R *, R *, octave_idx_type,
-                                             octave_idx_type, octave_idx_type))
+                                             octave_idx_type, octave_idx_type,
+                                             bool),
+                    bool includenan = false)
 {
   octave_idx_type l, n, u;
   dim_vector dims = src.dims ();
   get_extent_triplet (dims, dim, l, n, u);
 
   Array<R> ret (dims);
-  mx_cumminmax_op (src.data (), ret.fortran_vec (), l, n, u);
+  mx_cumminmax_op (src.data (), ret.fortran_vec (), l, n, u, includenan);
 
   return ret;
 }
@@ -1639,7 +1965,9 @@ template <typename R>
 inline Array<R>
 do_mx_cumminmax_op (const Array<R>& src, Array<octave_idx_type>& idx, int dim,
                     void (*mx_cumminmax_op) (const R *, R *, octave_idx_type *,
-                                             octave_idx_type, octave_idx_type, octave_idx_type))
+                                             octave_idx_type, octave_idx_type,
+                                             octave_idx_type, bool),
+                    bool includenan = false)
 {
   octave_idx_type l, n, u;
   dim_vector dims = src.dims ();
@@ -1649,7 +1977,7 @@ do_mx_cumminmax_op (const Array<R>& src,
   if (idx.dims () != dims) idx = Array<octave_idx_type> (dims);
 
   mx_cumminmax_op (src.data (), ret.fortran_vec (), idx.fortran_vec (),
-                   l, n, u);
+                   l, n, u, includenan);
 
   return ret;
 }
diff --git a/liboctave/operators/mx-op-decl.h b/liboctave/operators/mx-op-decl.h
--- a/liboctave/operators/mx-op-decl.h
+++ b/liboctave/operators/mx-op-decl.h
@@ -286,12 +286,12 @@ class boolNDArray;
 // scalar by N-D array min/max ops
 
 #define MINMAX_DECLS(T, S, API)                 \
-  extern API T min (S d, const T& m);           \
-  extern API T min (const T& m, S d);           \
-  extern API T min (const T& a, const T& b);    \
-  extern API T max (S d, const T& m);           \
-  extern API T max (const T& m, S d);           \
-  extern API T max (const T& a, const T& b);
+  extern API T min (S d, const T& m, bool includenan = false);           \
+  extern API T min (const T& m, S d, bool includenan = false);           \
+  extern API T min (const T& a, const T& b, bool includenan = false);    \
+  extern API T max (S d, const T& m, bool includenan = false);           \
+  extern API T max (const T& m, S d, bool includenan = false);           \
+  extern API T max (const T& a, const T& b, bool includenan = false);
 
 // permutation matrix by matrix ops and vice versa
 
diff --git a/liboctave/operators/mx-op-defs.h b/liboctave/operators/mx-op-defs.h
--- a/liboctave/operators/mx-op-defs.h
+++ b/liboctave/operators/mx-op-defs.h
@@ -562,23 +562,48 @@ along with Octave; see the file COPYING.
 
 #define SND_MINMAX_FCN(FCN, OP, T, S)                                   \
   T                                                                     \
-  FCN (S d, const T& m)                                                 \
+  FCN (S d, const T& m, bool includenan)                                \
   {                                                                     \
-    return do_sm_binary_op<T::element_type, S, T::element_type> (d, m, mx_inline_x##FCN); \
+    void (*op) (size_t, T::element_type *, S,                           \
+                const T::element_type *) throw ();                      \
+                                                                        \
+    if (includenan)                                                     \
+      op = mx_inline_x##FCN##_inan;                                     \
+    else                                                                \
+      op = mx_inline_x##FCN;                                            \
+                                                                        \
+    return do_sm_binary_op<T::element_type, S, T::element_type> (d, m,  \
+                                                                 op);   \
   }
 
 #define NDS_MINMAX_FCN(FCN, OP, T, S)                                   \
   T                                                                     \
-  FCN (const T& m, S d)                                                 \
+  FCN (const T& m, S d, bool includenan)                                \
   {                                                                     \
-    return do_ms_binary_op<T::element_type, T::element_type, S> (m, d, mx_inline_x##FCN); \
+    void (*op) (size_t, T::element_type *,                              \
+                const T::element_type *, S) throw ();                   \
+                                                                        \
+    if (includenan)                                                     \
+      op = mx_inline_x##FCN##_inan;                                     \
+    else                                                                \
+      op = mx_inline_x##FCN;                                            \
+                                                                        \
+    return do_ms_binary_op<T::element_type, T::element_type, S> (m, d,  \
+                                                                 op);   \
   }
 
 #define NDND_MINMAX_FCN(FCN, OP, T, S)                                  \
   T                                                                     \
-  FCN (const T& a, const T& b)                                          \
+  FCN (const T& a, const T& b, bool includenan)                         \
   {                                                                     \
-    return do_mm_binary_op<T::element_type, T::element_type, T::element_type> (a, b, mx_inline_x##FCN, mx_inline_x##FCN, mx_inline_x##FCN, #FCN); \
+    if (includenan)                                                     \
+      return do_mm_binary_op<T::element_type, T::element_type, T::element_type> (a, b, mx_inline_x##FCN##_inan, \
+                                                                                 mx_inline_x##FCN##_inan, \
+                                                                                 mx_inline_x##FCN##_inan, #FCN); \
+                                                                        \
+    return do_mm_binary_op<T::element_type, T::element_type, T::element_type> (a, b, mx_inline_x##FCN, \
+                                                                               mx_inline_x##FCN, \
+                                                                               mx_inline_x##FCN, #FCN); \
   }
 
 #define MINMAX_FCNS(T, S)                       \
